import {
  Component,
  OnInit,
  ViewChild,
  ElementRef,
  Input,
  EventEmitter,
  Output
} from "@angular/core";
@Component({
  selector: "app-file-upload-button",
  templateUrl: "./file-upload-button.component.html",
  styleUrls: ["./file-upload-button.component.css"]
})
export class FileUploadButtonComponent implements OnInit {
  private users: any;
  @ViewChild("myInput") myInputVariable: any;
  @Input("buttonTitle") buttonTitle: string;
  @Input("fileSizeLimit") fileSizeLimit: string;
  @Input("errorMessage") errorMessage: string;
  @Output() onChangeFile = new EventEmitter<any>();

  ngOnInit() {}
  // private errorMessage: string = "";

  cacheData: any = {
    fileObj: {}
  };

  reset() {
    this.myInputVariable.nativeElement.value = "";
    this.cacheData = {
      fileObj: {}
    };
    this.showFileTooLargeMessage = false;
  }

  imageFileObject: any = {};
  uploadedFilename: any = "";
  private base64textString: String = "";
  changeFile(event) {
    this.imageFileObject = event.target.files;
    this.uploadedFilename = event.target.files[0].name;
    this.handleFileSelect(event);
  }
  showFileTooLargeMessage = false;
  handleFileSelect(evt) {
    var files = evt.target.files;
    var file = files[0];
    var fileSize = file.size / 1024;

    if (files && file && fileSize <= Number(this.fileSizeLimit)) {
      this.showFileTooLargeMessage = false;
      var reader = new FileReader();
      this.cacheData = {
        ...this.cacheData,
        fileObj: file
      };
      console.log(this.cacheData);
      reader.onload = this._handleReaderLoaded.bind(this);
      reader.readAsBinaryString(file);
    } else {
      this.reset();
      this.showFileTooLargeMessage = true;
    }
  }

  _handleReaderLoaded(readerEvt) {
    var binaryString = readerEvt.target.result;
    this.base64textString = btoa(binaryString);
    this.cacheData = {
      ...this.cacheData,
      encodedImage: btoa(binaryString),
      encodedImageType: this.cacheData["fileObj"].type.split("/")[1]
    };
    this.onChangeFile.emit(this.cacheData)
  }
}
